## debian-installer 20171204pureos2

=== build/Makefile ===
#!/usr/bin/make -f
#
# Debian Installer system makefile.
# Copyright 2001-2003 by Joey Hess <joeyh@debian.org> and the d-i team.
# Licensed under the terms of the GPL.
#
# This makefile builds a debian-installer system and bootable images from 
# a collection of udebs which it downloads from a Debian archive. See
# README for details.
#
#
# General layout of our build directory hierarchy
#
# build/config/[<subarch>/][<medium>/][<flavour>/]<leaf-config>
# build/tmp/[<subarch>/][<medium>/][<flavour>/]<build-area>
# build/dest/[<subarch>/][<medium>/][<flavour>-]<images>
#
# Items in brackets can be left out if they are superfluous.
#
# These following <image> names are conventional.
#
# For small changeable media (floppies and the like):
# - boot.img, root.img, driver.img
#
# For single bootable images (e.g. tftp boot images):
# - boot.img
#
# For compressed single bootable images (harddisk or hd emulation):
# - boot.img.gz
#
# If those are not bootable:
# - root.img.gz
#
# Raw kernel images:
# - vmlinux or vmlinuz
#
# Example:
#
# dest/
# |-- cdrom-boot.img
# |-- floppy
# |   |-- access
# |   |   |-- boot.img
# |   |   |-- drivers.img
# |   |   `-- root.img
# |   |-- boot.img
# |   |-- cd-drivers.img
# |   |-- net-drivers.img
# |   `-- root.img
# |-- hd-media-boot.img.gz
# `-- netboot
#     |-- initrd.gz
#     `-- vmlinuz
#

# Temporary workaround for #823881:
export MTOOLS_SKIP_CHECK=1

# Add to PATH so dpkg will always work, and so local programs will be found.
PATH := util:$(PATH):/usr/sbin:/sbin
EATMYDATA = $(shell which eatmydata 2>/dev/null)
gzip = $(shell which pigz >/dev/null 2>&1 && echo "pigz -n -T" || echo "gzip -n")

# We don't want this to be run each time we re-enter.
ifndef DEB_HOST_ARCH
DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM = $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_CPU DEB_HOST_GNU_SYSTEM DEB_HOST_MULTIARCH
endif

define drop_lang
	@echo "Dropping languages: $(1)"
	@set -e; \
	for FILE in $$(find $(TREE)/var/lib/dpkg -name "*.templates"); do \
		perl -e 'my $$status=0; my $$drop=shift; while (<>) { if (/^[A-Z]/ || /^$$/) { if (/^(Choices|Description|Indices|Default)-($$drop)/ && ! /^Choices-C:/) { $$status = 0 } else { $$status = 1 } } print if ($$status); }' $(1) < $$FILE > temp; \
		mv temp $$FILE; \
	done
endef

# We loop over all needed combinations of ARCH, SUBARCH, MEDIUM, FLAVOUR
# via recursive make calls. ARCH is constant, we don't support
# crosscompiling.
ARCH = $(DEB_HOST_ARCH)

# By default, we just advertise what we can do.
.PHONY: all
all: list

# Globally useful variables.
targetstring = $(patsubst _%,%,$(if $(SUBARCH),_$(SUBARCH),)$(if $(MEDIUM),_$(MEDIUM),)$(if $(FLAVOUR),_$(FLAVOUR),))
targetdirs = $(subst _,/,$(targetstring))

# Overridden in config/hurd.cfg
define genext2fs
  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -m 0
endef

# Configurations for the varying ARCH, SUBARCH, MEDIUM, FLAVOUR.
# For simplicity, we use a similiar tree layout for config/, tmp/
# and dest/.
#
# Cheap trick: if one of the variables isn't defined, we run in
# a non-existing file and ignore it.
include config/common
include config/dir
-include config/$(ARCH).cfg
-include config/$(ARCH)/$(SUBARCH).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM)/$(FLAVOUR).cfg
-include config/local

export KEYRING
export KERNELVERSION
export LOCALUDEBDIR
export SOURCE_DATE_EPOCH

ifneq ($(shell id -u),0)
  ROOTCMD ?= fakeroot
endif

# Useful command sequences
define submake
  $(ROOTCMD) $(MAKE) --no-print-directory -j1
endef

define recurse_once
  @set -e; $(submake) $(1)_$(2)
endef

define recurse_many
  @set -e; $(foreach var,$($(1)_SUPPORTED) $(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(submake) $(2)_$(3) $(1)=$(var);)
endef

define recurse
  $(if $($(1)_SUPPORTED)$(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(call recurse_many,$(1),$(2),$(3)),$(call recurse_once,$(2),$(3)))
endef

define mkinitramfs
  (cd $(TREE) && find . | sort | cpio --quiet -o -H newc) > 
endef

# Limit on mfsroot size. It is determined by NKPT (in <machine/pmap.h).
# On amd64, it can be increased by increasing this variable.  On i386,
# this is a hard limit due to constraints of 4 GiB VM space.
ifeq ($(DEB_HOST_ARCH),kfreebsd-i386)
MFSROOT_LIMIT := 42m
else ifeq ($(DEB_HOST_ARCH),kfreebsd-amd64)
# See Bug#783773 for derivation.
MFSROOT_LIMIT := 78m
endif

define mkfs.ufs1
  sh -c 'makefs -t ffs -T $(SOURCE_DATE_EPOCH) -s $(MFSROOT_LIMIT) -f 3000 -o minfree=0,version=1 $$0 ${TREE}'
endef

define e2fsck
  e2fsck -fy
endef

# Define MKFS_JFFS2 in the config file for your target.
# For example: MKFS_JFFS2 = mkfs.jffs2 -f -p -b -e 0x20000
define mkjffs2
  $(MKFS_JFFS2) -d $(TREE) -o
endef

# A generic recursion rule
.PHONY: all_%
all_%:
	@install -d $(STAMPS)
	$(call recurse,SUBARCH,subarch,$*)

.PHONY: subarch_%
subarch_%:
	$(call recurse,MEDIUM,medium,$*)

.PHONY: medium_%
medium_%:
	$(call recurse,FLAVOUR,flavour,$*)

.PHONY: flavour_%
flavour_%:
	$(if $(targetstring),@$(submake) _$*)

# Validate a targetstring, echo env variables for valid ones
.PHONY: validate_%
validate_%:
	@set -e; \
	SUBARCH= var='$(subst _, ,$(subst validate_,,$@))'; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(SUBARCH_SUPPORTED)$(SUBARCH_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(SUBARCH_SUPPORTED) $(SUBARCH_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || SUBARCH=$$tmp; \
	$(submake) medium_validate SUBARCH=$$SUBARCH var="$$var"

.PHONY: medium_validate
medium_validate:
	@set -e; \
	MEDIUM= var="$(strip $(patsubst $(SUBARCH)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(MEDIUM_SUPPORTED)$(MEDIUM_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(MEDIUM_SUPPORTED) $(MEDIUM_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || MEDIUM=$$tmp; \
	$(submake) flavour_validate MEDIUM=$$MEDIUM var="$$var"

.PHONY: flavour_validate
flavour_validate:
	@set -e; \
	FLAVOUR= var="$(strip $(patsubst $(MEDIUM)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(FLAVOUR_SUPPORTED)$(FLAVOUR_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) $(FLAVOUR_SUPPORTED_EXTRA) | grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
	$(submake) finish_validate FLAVOUR=$$FLAVOUR var="$$var"

.PHONY: finish_validate
finish_validate:
	@set -e; \
	var="$(strip $(patsubst $(FLAVOUR)%,%,$(var)))"; \
	if [ -z "$$var" ]; then \
		echo SUBARCH=$$SUBARCH MEDIUM=$$MEDIUM FLAVOUR=$$FLAVOUR; \
	else \
		echo SUBARCH= MEDIUM= FLAVOUR=; \
	fi;


# List all targets useful for direct invocation.
.PHONY: list
list:
	@echo "Useful targets:"
	@echo
	@echo "list"
	@echo "all_build"
	@echo "all_rebuild"
	@echo "stats"
	@echo "all_clean"
	@echo "reallyclean"
	@echo
	@$(submake) all_list RECURSE_EXTRA=1

.PHONY: _list
_list:
	@set -e; \
	echo build_$(targetstring); \
	echo stats_$(targetstring); \
	$(if $(findstring $(MEDIUM),$(WRITE_MEDIA)),echo write_$(targetstring);) \
	echo clean_$(targetstring); \
	echo rebuild_$(targetstring); \
	echo demo_$(targetstring); \
	echo shell_$(targetstring); \
	echo uml_$(targetstring); \
	echo qemu_$(targetstring); \
	echo


# Clean all targets.
.PHONY: reallyclean
reallyclean: all_clean
	for png in $(shell awk -F= '/^SPLASH_PNG=/ {print $$2}' config/*.cfg); do if [ -f $${png%%.png}.svg ]; then rm -f $$png; fi; done
	rm -rf $(APTDIR) $(APTDIR).udeb $(APTDIR).deb $(BASE_DEST) $(BASE_TMP) $(SOURCEDIR) $(DEBUGUDEBDIR)
	rm -f sources.list sources.list.udeb $(LOCALUDEBDIR)/Packages.gz $(LOCALUDEBDIR)/Packages
	rm -rf $(UDEBDIR) $(STAMPS)

# For manual invocation, we provide a generic clean rule.
.PHONY: clean_%
clean_%:
	@$(submake) _clean $(shell $(submake) $(subst clean_,validate_,$@))
	update-manifest

# The general clean rule.
.PHONY: _clean
_clean: tree_umount
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	-rm -f $(STAMPS)tree-unpack-$(targetstring)-stamp $(STAMPS)tree-$(targetstring)-stamp $(STAMPS)extra-$(targetstring)-stamp $(STAMPS)get_udebs-$(targetstring)-stamp
	rm -f $(TEMP)/diskusage.txt
	rm -f $(TEMP)/all.utf
	rm -f $(TEMP)/unifont.bdf $(TREE)/lib/unifont.bgf
	rm -f pkg-lists/standard-udebs pkg-lists/kernel-module-udebs
	rm -rf $(TARGET)
	rm -rf $(TEMP)

# all_build is provided automagically, but for manual invocation
# we provide a generic build rule.
.PHONY: build_%
build_%:
	@install -d $(STAMPS)
	@$(submake) _build $(shell $(submake) $(subst build_,validate_,$@))

# The general build rule.
.PHONY: _build
_build:
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	@$(submake) tree_umount $(EXTRATARGETS) $(TARGET)

# Convenience rules to clean and build.
.PHONY: rebuild_%
rebuild_%:
	@$(submake) clean_$(subst rebuild_,,$@) build_$(subst rebuild_,,$@)

.PHONY: _rebuild
_rebuild:
	@$(submake) _clean _build

# Run before releasing built files.
release:
	egrep '^[[:space:]]' $(BASE_DEST)/MANIFEST.udebs | \
		sed 's/^[[:space:]]*//' | sort | uniq > $(BASE_DEST)/udeb.list
	rm -f $(BASE_DEST)/MD5SUMS $(BASE_DEST)/SHA256SUMS
	cd $(BASE_DEST) && md5sum `find -L . -type f | sort` > MD5SUMS # XXX remove this
	cd $(BASE_DEST) && sha256sum `find -L . -type f | sort` > SHA256SUMS

# The general tree target.
$(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
	dh_testroot
	@[ -d ../debian ] || { echo "directory '../debian' not found; complete source of 'debian-installer' package is required"; false; }
	cd .. && dpkg-checkbuilddeps
	@rm -f $@

	# This build cannot be restarted, because dpkg gets confused.
	rm -rf $(TREE)
	# Set up the basic files [u]dpkg needs.
	mkdir -p $(DPKGDIR)/info
	touch $(DPKGDIR)/status
	# Create a tmp tree
	mkdir -p $(TREE)/tmp
	# Only dpkg needs this stuff, so it can be removed later.
	mkdir -p $(DPKGDIR)/updates/
	touch $(DPKGDIR)/available

ifdef TRANSSTATUS
	# Include translation status file; warn if older than 2 weeks.
	# Do this first to make possible warnings more visible.
	@echo; \
	if [ -f "$(TRANSSTATUS)" ]; then \
		if [ "$(USE_PROPOSED_UPDATES)" != 1 ]; then \
			olddate=$$(grep "^# Generated on:" $(TRANSSTATUS) | sed "s/.*: //"); \
			if [ "$$olddate" ]; then \
				if [ $$(( $$(date -u "+%s") - \
				          $$(date -d "$$olddate" "+%s") \
				       )) -gt 1209600 ]; then \
					echo "WARNING: The data in '$(TRANSSTATUS)' is older than 2 weeks."; \
					echo "         Should it maybe be updated?"; \
					sleep 15; \
				fi; \
			else \
				echo "WARNING: no timestamp found in $(TRANSSTATUS)."; \
				sleep 15; \
			fi; \
		fi; \
		mkdir -p $(TREE)/usr/share/localechooser; \
		cp $(TRANSSTATUS) $(TREE)/usr/share/localechooser/translation-status; \
	else \
		echo "WARNING: the file $(TRANSSTATUS) does not exist."; \
		sleep 5; \
	fi
endif

	# Unpack the udebs with dpkg. This command must run as root
	# or fakeroot.
	echo -n > $(TEMP)/diskusage.txt
	set -e; \
	oldsize=0; oldblocks=0; oldcount=0; for udeb in $(UDEBDIR)/*.udeb ; do \
		if [ -f "$$udeb" ]; then \
			pkg=`basename $$udeb` ; \
			$(EATMYDATA) dpkg $(DPKG_UNPACK_OPTIONS) --path-include='*' --log=/dev/null --root=$(TREE) --unpack $$udeb ; \
			newsize=`du -bs $(TREE) | awk '{print $$1}'` ; \
			newblocks=`du -s $(TREE) | awk '{print $$1}'` ; \
			newcount=`find $(TREE) -type f | wc -l | awk '{print $$1}'` ; \
			usedsize=`echo $$newsize - $$oldsize | bc`; \
			usedblocks=`echo $$newblocks - $$oldblocks | bc`; \
			usedcount=`echo $$newcount - $$oldcount | bc`; \
			version=`dpkg-deb --info $$udeb | sed -n 's/^ Version: //p' | sed 's/+b[0-9]*$$//g'` ; \
			source=`dpkg-deb --info $$udeb | sed -n 's/^ Source: //p'` ; \
			if [ -z "$$source" ]; then \

=== debian/changelog ===
debian-installer (20171204pureos2) green; urgency=medium

  * No-change rebuild

 -- Matthias Klumpp <matthias.klumpp@puri.sm>  Fri, 19 Jan 2018 19:40:42 +0100

debian-installer (20171204pureos1) green; urgency=medium

  * Merge with Debian unstable, remaining changes:
    - Customize settings for PureOS
    - Bump kernel ABI version to 4.14.0-3

 -- Matthias Klumpp <matthias.klumpp@puri.sm>  Sat, 06 Jan 2018 20:24:02 +0100

=== debian/control ===
Source: debian-installer
Section: devel
Priority: optional
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Cyril Brulebois <kibi@debian.org>
Standards-Version: 3.9.5
Vcs-Git: https://anonscm.debian.org/git/d-i/debian-installer.git
Vcs-Browser: https://anonscm.debian.org/cgit/d-i/debian-installer.git
Build-Depends:
# Base build dependencies:
	debhelper (>= 7.0.0),
#		Of course.
	apt (>= 0.8.16),
# 		Used for downloading udebs.
	apt-utils,
# 		apt-ftparchive is used for including localudebs.
	gnupg,
#		New versions of apt need gnupg for security checks.
	debian-archive-keyring (>= 2006.11.22),
#		To provide the archive key for security checks.
	dctrl-tools,
#		Various manipulations of the udeb Packages files.
	wget,
#		Used to test validity of mirrors.
	bc,
#		Used for some image size calculations.
	debiandoc-sgml,
#		partman's manual is in debiandoc.
	xsltproc,
	docbook-xml,
	docbook-xsl,
#		The d-i internals manual is in DocBook XML.
	libbogl-dev,
#		For bdftobogl used in font reduction.
#	
# Library build dependencies:
	libnewt0.52,
#		libnewt0.52 does not have a udeb, mklibs-copy will copy the
#		the library from the debian package.
	libgcc1 [i386 amd64],
#		On x86 we need to include /lib/libgcc_s.so.1 in g-i initrds to
#		work around #373253 until upstream can remove pthread_cancel()
#		calls in directfb. For now, this is done by setting EXTRAFILES.
# 
# Filesystem tools:
	genext2fs (>= 1.3-7.1),
#		For creating ext2 filesystems without being root.
#		1.3-7.1 fixes issues on several arches.
	e2fsprogs,
#		genext2fs doesn't produce perfect filesystems, so we fsck
#		them.
#		Lintian: Yes, we know it's essential. We prefer not to
#		count on it remaining so.
	mklibs (>= 0.1.40), mklibs-copy (>= 0.1.40),
#		We use mklibs for library reduction.
	genisoimage [!s390 !s390x],
#		For making mini isos.
	genromfs [sparc sparc64],
#		Used for creating sparc floppies (which are not built by
#		default.)
	hfsutils [powerpc],
#		For making bootable HFS USB sticks for powerpc.
	dosfstools [i386 m68k amd64 armhf arm64],
#		For creating FAT filesystems with mkfs.msdos.
#		Of course i386/amd64 use this for floppies, CDs etc.
#		m68k uses it for atari floppies
#		armhf uses it for building bootable SD card images
	cpio,
#		For creating initramfs images.
	xz-utils,
#		For compressing initramfs images.
	devio [armeb armel],
#		Tool to read and write from block devices, used to byteswap
#		kernels and add nslu2 boot magic.
	dns323-firmware-tools (>= 0.7.3-1~) [armel],
#		For building firmware images for the D-Link DNS-32(0|3).
	u-boot-tools [armel armhf],
#		For creating u-boot images
# 
# Boot loaders:
#	On many arches boot loaders are copied onto or ran on the boot
#	images in one way or another. There's a reason our mailing list is
#	still called debian-boot..
	syslinux [i386 amd64],
	syslinux-utils [i386 amd64],
	isolinux [i386 amd64],
	pxelinux [i386 amd64],
	syslinux-common (>= 3:6) [i386 amd64],
#		With isohybrid.
	yaboot [powerpc ppc64],
#		For all our powerpc boot needs. Well, not really.
	aboot (>= 0.9b-2) [alpha],
#		A previous version didn't have netabootwrap.
	palo [hppa],
#		Bootloader for hppa machines, to make netboot images.
	silo [sparc sparc64],
#		Using silo is problematic since it needs to run as root,
#		so images that need it are not built by default, but we
#		include it for completeness.
	sparc-utils [sparc sparc64],
#		For elftoaout and piggyback, to make netboot images.
	atari-bootstrap [m68k],
#		Booting and other tools for Atari systems.
	vmelilo [m68k],
	m68k-vme-tftplilo [m68k],
#		For VME machines, although it doesn't yet support running
#		as non-root, the install will try to use it and fall back
#		to a warning when it fails.
	amiboot [m68k],
#		Bootloader for m68k/amiga machines.
	emile [m68k],
	emile-bootblocks [m68k],
#		Bootloader for m68k/mac machines.
	grub-efi-amd64-bin [amd64], grub-efi-arm64-bin [arm64], grub-efi-ia32-bin [i386],
	grub-common [amd64 arm64 i386], xorriso,
#		Used to make EFI bootable images
	grub-ieee1275-bin [ppc64el],
#		IEEE1275 bootloader support.
	u-boot-imx [armhf],
	u-boot-omap (>= 2016.09~rc1) [armhf],
	u-boot-sunxi [armhf],
	u-boot-rockchip (>= 2017.07+dfsg1-3) [armhf],
#		U-boot binaries for armhf systems without u-boot in flash memory
	u-boot (>= 2016.01+dfsg1-1~) [armel],
#		U-boot binaries for armel systems
# 
# Architecture specific build dependencies:
	tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64],
#		For todos, used on files that need to be accessible from
#		DOS.
	mtools [i386 m68k amd64 armhf arm64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#		mcopy is used to put files onto FAT filesystems w/o
#		mounting them.
# 
	kmod [linux-any],
#		depmod.
# 
	bf-utf-source [!s390 !s390x],
#		Contains the unicode font we use. Not a udeb since we
#		perform font reduction at build time.
	mkvmlinuz [powerpc ppc64],
#		Used to make powerpc images that can boot direct from
#		firmware w/o using a boot loader.
	openssl,
#		Used to encrypt a firmware image so an ARM based device
#		(Thecus N2100) will accept it. Also useful on other
#		architectures if SSL_CERTS has been set locally.
	win32-loader (>= 0.7.2) [i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#		Alternative boot method for win32 platforms.
	makefs (>= 20100306-5+kbsd8u1~) [kfreebsd-any],
#		Used to create an UFS1 filesystem from a directory tree.
	grub-pc (>= 2.02~beta2~) [kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#		Used as the CD-ROM's bootloader
	xorriso (>= 1.3.2-1~) [kfreebsd-i386 kfreebsd-amd64 hurd-i386],
#               Used by grub-pc to create the CD-ROM images
	debian-ports-archive-keyring [sh4 sparc64],
#		Used for architectures hosted on debian-ports.org
	librsvg2-bin [any-amd64 any-i386],
#		Used to convert splash SVG to splash PNG during build
	fdisk [armhf] | util-linux (<< 2.29.2-3~) [armhf],
#		sfdisk is used by util/gen-hd-image when creating SD card
#		images for armhf systems. Starting with buster, it is no longer
#		part of util-linux but split out into a separate, non-essential
#		"fdisk" package. For more information, please cf.
#		https://lists.debian.org/debian-devel-announce/2017/08/msg00005.html

Package: debian-installer
Architecture: any
Built-Using: ${initrd:Built-Using}, ${extra:Built-Using}
Depends: ${misc:Depends}
Description: Debian Installer documentation
 This package currently only contains some documentation for the Debian
 installer. We welcome suggestions about what else to put in it.

=== debian/rules ===
#! /usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)
SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2)

# Daily builds vs. uploads to unstable:
ifeq (${SUITE},UNRELEASED)
USE_UDEBS_FROM=landing
TRANSSTATUS=
BOOTMENU_BEEP=n
else
USE_UDEBS_FROM=landing
USE_PROPOSED_UPDATES=0
TRANSSTATUS=translation-status
BOOTMENU_BEEP=y
endif

# Adjust for non-released ports if needed:
RELEASE_ARCHES=amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x
ifeq (,$(filter $(ARCH), $(RELEASE_ARCHES)))
USE_UNRELEASED=1
USE_UDEBS_FROM=landing
endif

ARCHIVEDIR=debian/tmp/installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(DATE)
IMAGEDIR=$(DESTDIR)/images
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

export SOURCE_DATE_EPOCH

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(MAKE) -C build reallyclean
	$(MAKE) -C doc/devel/partman clean
	$(MAKE) -C doc/devel/internals clean

# Must run as root, so is not run as part of regular build.
build-images:
	$(MAKE) -C build all_build stats release \
		USE_UDEBS_FROM=$(USE_UDEBS_FROM) BUILD_DATE=$(DATE) \
		USE_PROPOSED_UPDATES=$(USE_PROPOSED_UPDATES) \
		USE_UNRELEASED=$(USE_UNRELEASED) \
		TRANSSTATUS=$(TRANSSTATUS) BOOTMENU_BEEP=$(BOOTMENU_BEEP)

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	rm -f $@
	$(MAKE) -C doc/devel/internals
	$(MAKE) -C doc/devel/partman
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	debian/rules build-images

	install -d $(IMAGEDIR)
	cp -a build/dest/* $(IMAGEDIR)
	ln -s $(DATE) $(ARCHIVEDIR)/current

binary-arch: install  
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs doc/* -X Makefile -X build.sh -X .xsl \
		-X internals.xml -X partman-doc.sgml -X .gitignore
	dh_compress
	dh_fixperms

	./build/util/write-built-using

	dh_gencontrol
	dh_md5sums
	dh_builddeb
	./build/util/gen-tarball debian/tmp ../$(TARNAME)
	dpkg-distaddfile $(TARNAME) raw-installer -

binary-indep:

binary: binary-indep binary-arch 
.PHONY: build build-images clean binary-indep binary-arch binary install

## debian-installer 20180610

=== debian/changelog ===
debian-installer (20180610) unstable; urgency=medium

  [ Cyril Brulebois ]
  * Bump Linux kernel ABI from 4.13.0-1 to 4.16.0-2
  * Replace c_rehash with openssl rehash (Closes: #895074). That should only
    affect builds with SSL_CERTS enabled; regular HTTPS support comes from
    ca-certificates anyway.
  * Update Vcs-{Browser,Git} to point to salsa (alioth's replacement).
  * Set Acquire::Languages to none since translations aren't needed.
  * Avoid warnings regarding missing /etc/apt/{apt.conf.d,preferences.d}
    by setting their respective apt config variables to /dev/null.
  * Duplicate Apt::Architecture into Apt::Architectures because of course
    apt has two options, the latter getting foreign architectures if not
    specified, even if the former is.
  * Run fc-cache when /etc/fonts or /usr/share/fonts exist, to avoid
    having to generate UUIDs at runtime, which can be hard because of
    missing entropy (Closes: #898468).
  * Add fontconfig to Build-Depends accordingly.

  [ Paul Tagliamonte ]
  * Add support for the NanoPiNeo

  [ Aurelien Jarno ]
  * Drop the build-depends on libnewt0.52, the library now provides an udeb.

  [ Vagrant Cascadian ]
  * [arm64] Generate u-boot media for pine64_plus:
    - Add Build-Depends on u-boot-sunxi, atf-allwinner, u-boot-tools and
      device-tree-compiler.
    - Add atf-allwinner to Built-Using.
  * [armhf] netboot: Enable grub-efi mini.iso.

  [ John Paul Adrian Glaubitz ]
  * hppa: Use compressed kernel image by default.
  * sparc64: Use xz compression for initrd during netboot image build.

  [ Paul Wise ]
  * Switch get-packages from setting apt-get options through the command
    line to writing a configuration file referred to by APT_CONFIG. The
    latter should ensure a stricter separation from the system config.

  [ Samuel Thibault ]
  * Do not create /dev/console and /dev/null on hurd-any, they are initialized
    at runtime.

  [ Vagrant Cascadian ]
  * [armhf] Add support for Cubietruck_plus.

 -- Cyril Brulebois <kibi@debian.org>  Sun, 10 Jun 2018 23:48:13 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
 Uploaders: Cyril Brulebois <kibi@debian.org>
 Standards-Version: 3.9.5
-Vcs-Git: https://anonscm.debian.org/git/d-i/debian-installer.git
-Vcs-Browser: https://anonscm.debian.org/cgit/d-i/debian-installer.git
+Vcs-Git: https://salsa.debian.org/installer-team/debian-installer.git
+Vcs-Browser: https://salsa.debian.org/installer-team/debian-installer
 Build-Depends:
 # Base build dependencies:
 	debhelper (>= 7.0.0),
@@ -34,9 +34,6 @@
 #		For bdftobogl used in font reduction.
 #	
 # Library build dependencies:
-	libnewt0.52,
-#		libnewt0.52 does not have a udeb, mklibs-copy will copy the
-#		the library from the debian package.
 	libgcc1 [i386 amd64],
 #		On x86 we need to include /lib/libgcc_s.so.1 in g-i initrds to
 #		work around #373253 until upstream can remove pthread_cancel()
@@ -74,7 +71,7 @@
 #		kernels and add nslu2 boot magic.
 	dns323-firmware-tools (>= 0.7.3-1~) [armel],
 #		For building firmware images for the D-Link DNS-32(0|3).
-	u-boot-tools [armel armhf],
+	u-boot-tools [armel armhf arm64],
 #		For creating u-boot images
 # 
 # Boot loaders:
@@ -112,6 +109,7 @@
 	emile-bootblocks [m68k],
 #		Bootloader for m68k/mac machines.
 	grub-efi-amd64-bin [amd64], grub-efi-arm64-bin [arm64], grub-efi-ia32-bin [i386],
+	grub-efi-arm-bin [armhf],
 	grub-common [amd64 arm64 i386], xorriso,
 #		Used to make EFI bootable images
 	grub-ieee1275-bin [ppc64el],
@@ -119,8 +117,13 @@
 	u-boot-imx [armhf],
 	u-boot-omap (>= 2016.09~rc1) [armhf],
 	u-boot-sunxi [armhf],
+	u-boot-sunxi (>= 2018.03) [arm64],
 	u-boot-rockchip (>= 2017.07+dfsg1-3) [armhf],
 #		U-boot binaries for armhf systems without u-boot in flash memory
+	atf-allwinner [arm64],
+	device-tree-compiler [arm64],
+#		arm-trusted-firmware for allwinner, used in combination with
+#		u-boot-sunxi to produce bootable arm64 images.
 	u-boot (>= 2016.01+dfsg1-1~) [armel],
 #		U-boot binaries for armel systems
 # 
@@ -163,6 +166,8 @@
 #		part of util-linux but split out into a separate, non-essential
 #		"fdisk" package. For more information, please cf.
 #		https://lists.debian.org/debian-devel-announce/2017/08/msg00005.html
+	fontconfig,
+#		Used to generate a font cache through fc-cache, for gtk flavours
 
 Package: debian-installer
 Architecture: any

## debian-installer 20181206

=== debian/changelog ===
debian-installer (20181206) unstable; urgency=medium

  [ Cyril Brulebois ]
  * Update translation-status post-release.
  * Bump Linux kernel ABI from 4.16.0-2 to 4.18.0-3
  * Update translation-status for the release.

  [ Andreas B. Mundt ]
  * Make netboot.tar.gz archive structure for armhf identical to all other
    architectures:  Add top level directory ./ and a version.info file to
    the archive (closes: #902020).

  [ Raphaël Hertzog ]
  * Replace ttf-freefont-udeb by fonts-freefont-udeb as the former has been
    removed from unstable (and thus testing).

  [ John Paul Adrian Glaubitz ]
  * Add missing build dependency on debian-ports-archive-keyring for alpha,
    hppa, ia64, m68k, powerpc, powerpcspe, ppc64, riscv64 and x32.
  * ia64: Set KEYRING to debian-ports in build configuration.
  * powerpc: Set KEYRING to debian-ports in build configuration.
  * ppc64: Set KEYRING to debian-ports in build configuration.

  [ Philip Hands ]
  * fix a couple of remaining alioth references.

  [ Karsten Merker ]
  * Add basic riscv64 support.

  [ Samuel Thibault ]
  * Keep grub resolution in EFI boot, to avoid tiny fonts (closes: #910227).

  [ Vagrant Cascadian ]
  * [armhf] Remove Firefly-RK3288 image, as u-boot fails to boot due to
    #898520.
  * Remove u-boot-rockchip from Built-Using, as no targets use it.

  [ Holger Wansing]
  * Fix not-working F10 key function in help pages of boot screen.

  [ Luigi Toscano ]
  * Change some references of "KDE" into "KDE Plasma". Closes Salsa MR !4.

  [ Vagrant Cascadian ]
  * [arm64] Add u-boot image for pinebook.
  * [armhf] Add image for Sinovoip_BPI_M3. Thanks to Bernhard.

  [ YunQiang Su ]
  * [mips*el/loongson-3] add input modules to netboot image (Closes: #911664).

  [ Vagrant Cascadian ]
  * [armel] Disable OpenRD targets, no longer present in u-boot.

 -- Cyril Brulebois <kibi@debian.org>  Wed, 05 Dec 2018 17:47:54 +0000

=== debian/control ===
--- 
+++ 
@@ -116,8 +116,8 @@
 #		IEEE1275 bootloader support.
 	u-boot-imx [armhf],
 	u-boot-omap (>= 2016.09~rc1) [armhf],
-	u-boot-sunxi [armhf],
-	u-boot-sunxi (>= 2018.03) [arm64],
+	u-boot-sunxi (>= 2018.09) [armhf],
+	u-boot-sunxi (>= 2018.11) [arm64],
 	u-boot-rockchip (>= 2017.07+dfsg1-3) [armhf],
 #		U-boot binaries for armhf systems without u-boot in flash memory
 	atf-allwinner [arm64],
@@ -156,7 +156,7 @@
 #		Used as the CD-ROM's bootloader
 	xorriso (>= 1.3.2-1~) [kfreebsd-i386 kfreebsd-amd64 hurd-i386],
 #               Used by grub-pc to create the CD-ROM images
-	debian-ports-archive-keyring [sh4 sparc64],
+	debian-ports-archive-keyring [alpha hppa ia64 m68k powerpc powerpcspe ppc64 riscv64 sh4 sparc64 x32],
 #		Used for architectures hosted on debian-ports.org
 	librsvg2-bin [any-amd64 any-i386],
 #		Used to convert splash SVG to splash PNG during build

## debian-installer 20190118

=== debian/changelog ===
debian-installer (20190118) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * [arm64] Use arm-trusted-firmware instead of atf-allwinner to build
    pine64_plus and pinebook images.

  [ John Paul Adrian Glaubitz ]
  * alpha: Clean up formatting of build configuration file.
  * alpha: Remove fb-modules from cdrom and netboot package lists.
  * hppa: Clean up formatting of build configuration file.

  [ Cyril Brulebois ]
  * Bump Linux kernel ABI from 4.18.0-3 to 4.19.0-1
  * Update translation-status for the release.

  [ Vagrant Cascadian ]
  * [armhf] Re-enable Firefly-RK3288 image.
  * [armhf] Update Build-Depends for u-boot-rockchip.
  * Add u-boot-rockchip to Built-Using.

 -- Cyril Brulebois <kibi@debian.org>  Fri, 18 Jan 2019 21:43:12 +0100

=== debian/control ===
--- 
+++ 
@@ -108,7 +108,10 @@
 	emile [m68k],
 	emile-bootblocks [m68k],
 #		Bootloader for m68k/mac machines.
-	grub-efi-amd64-bin [amd64], grub-efi-arm64-bin [arm64], grub-efi-ia32-bin [i386],
+	shim-signed [amd64], grub-efi-amd64-signed [amd64],
+#	        Signed bootloader components for UEFI Secure Boot
+	grub-efi-arm64-bin [arm64],
+	grub-efi-ia32-bin [i386],
 	grub-efi-arm-bin [armhf],
 	grub-common [amd64 arm64 i386], xorriso,
 #		Used to make EFI bootable images
@@ -117,10 +120,10 @@
 	u-boot-imx [armhf],
 	u-boot-omap (>= 2016.09~rc1) [armhf],
 	u-boot-sunxi (>= 2018.09) [armhf],
-	u-boot-sunxi (>= 2018.11) [arm64],
-	u-boot-rockchip (>= 2017.07+dfsg1-3) [armhf],
+	u-boot-sunxi (>= 2018.11+dfsg-2) [arm64],
+	u-boot-rockchip (>= 2019.01+dfsg-1) [armhf],
 #		U-boot binaries for armhf systems without u-boot in flash memory
-	atf-allwinner [arm64],
+	arm-trusted-firmware [arm64],
 	device-tree-compiler [arm64],
 #		arm-trusted-firmware for allwinner, used in combination with
 #		u-boot-sunxi to produce bootable arm64 images.

## debian-installer 20190410

=== debian/changelog ===
debian-installer (20190410) unstable; urgency=medium

  [ Cyril Brulebois ]
  * Bump debhelper build-dep and compat from 7 to 11. Finally!
  * Fix “build-depends-on-1-revision build-depends u-boot-rockchip”,
    thanks to lintian.
  * Set dpkg source format explicitly as both dpkg-source and lintian
    are being excessively noisy.
  * Drop source.lintian-overrides: the only override was about the
    e2fsprogs build-dependency when it was still “Essential: yes”; as
    anticipated it's now only “Priority: required”.
  * Bump Standards-Version from 3.9.5 to 4.3.0; no changes required, with
    the usual exception regarding network access.
  * Review and merge Chris Lamb's work making d-i build reproducibly
    (Closes: #900918), with many thanks! Remaining issues seem related to
    fontconfig's cache and xorriso calls.
  * gen-tarball: specify the complete gzip command through a tar option
    instead of using the now-deprecated GZIP environment variable.
  * gen-tarball: use pigz if available, reducing build time.
  * Bump Linux kernel ABI from 4.19.0-1 to 4.19.0-4
  * Update translation-status for the release.

  [ Chris Lamb ]
  * Set BUILD_DATE based on SOURCE_DATE_EPOCH, rather than the other way
    around.
  * Ensure the GRUB memdisk images do not vary on filesystem ordering.
  * Ensure the GRUB memdisk images do not vary on filesystem timestamps.
  * Ensure that generated EFI images have a determinstic FAT volume ID.
  * When generating CPIO archives (initramfs, etc), ensure they are
    reproducible.
  * build/Makefile: Add a clamp_mtimes utility to avoid DRY violations.
  * 'clamp' the mtimes of various files before they are added to archives
    or media.
  * Specify --invariant to mkfs.fat(8) to ensure deterministic filesystem
    timestamps.
  * Increase the BUILD_DATE resolution to include the seconds component.
  * Clamp mtimes of the final build results in the destination directory.
  * Ensure that running the 'release' target does not alter the mtimes
    under dest/.
  * debian/control: Document that #900409 and #900410 are required for a
    reproducible build.
  * Ensure build is reproducible regardless of the user's
    umask(2). (Closes: #920631)
  * Ensure build is reproducible regardless of the underlying filesystem
    ordering. (Closes: #920676)

  [ John Paul Adrian Glaubitz ]
  * config: Set DEBIAN_RELEASE to unstable for all architectures
    in Debian Ports. (Closes: #920353)
  * pkg-lists: Add debian-ports-archive-keyring-udeb package for all
    architectures in Debian Ports for cdrom and netboot images.

  [ Holger Wansing ]
  * Add dark theme shortcut (Closes: #820911)

  [ Samuel Thibault ]
  * Rework dark theme shortcut.
  * Introduce dark menu theme.
  * Fix loading background image on netboot grub.

  [ Ben Hutchings ]
  * armel: Delete unused package list for ixp4xx (Closes: #921951)

  [ Vagrant Cascadian ]
  * [armhf] Add images for Novena.
  * Update versioned Build-Depends on u-boot-imx.
  * [armhf] Add images for BananaPiM2Berry. Thanks to Lucas Nussbaum.
  * Update versioned Build-Depends on u-boot-sunxi.

  [ Steve McIntyre ]
  * Switch to using buster artwork for the splash screen

 -- Cyril Brulebois <kibi@debian.org>  Wed, 10 Apr 2019 20:55:32 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
 Uploaders: Cyril Brulebois <kibi@debian.org>
-Standards-Version: 3.9.5
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/installer-team/debian-installer.git
 Vcs-Browser: https://salsa.debian.org/installer-team/debian-installer
 Build-Depends:
 # Base build dependencies:
-	debhelper (>= 7.0.0),
+	debhelper (>= 11),
 #		Of course.
 	apt (>= 0.8.16),
 # 		Used for downloading udebs.
@@ -62,8 +62,8 @@
 #		Of course i386/amd64 use this for floppies, CDs etc.
 #		m68k uses it for atari floppies
 #		armhf uses it for building bootable SD card images
-	cpio,
-#		For creating initramfs images.
+	cpio (>= 2.11+dfsg-6),
+#		For creating (reproducible) initramfs images.
 	xz-utils,
 #		For compressing initramfs images.
 	devio [armeb armel],
@@ -117,11 +117,11 @@
 #		Used to make EFI bootable images
 	grub-ieee1275-bin [ppc64el],
 #		IEEE1275 bootloader support.
-	u-boot-imx [armhf],
+	u-boot-imx (>= 2019.01+dfsg-3) [armhf],
 	u-boot-omap (>= 2016.09~rc1) [armhf],
-	u-boot-sunxi (>= 2018.09) [armhf],
+	u-boot-sunxi (>= 2019.01+dfsg-3) [armhf],
 	u-boot-sunxi (>= 2018.11+dfsg-2) [arm64],
-	u-boot-rockchip (>= 2019.01+dfsg-1) [armhf],
+	u-boot-rockchip (>= 2019.01+dfsg-1~) [armhf],
 #		U-boot binaries for armhf systems without u-boot in flash memory
 	arm-trusted-firmware [arm64],
 	device-tree-compiler [arm64],
@@ -136,7 +136,9 @@
 #		DOS.
 	mtools [i386 m68k amd64 armhf arm64 kfreebsd-i386 kfreebsd-amd64 hurd-i386],
 #		mcopy is used to put files onto FAT filesystems w/o
-#		mounting them.
+#		mounting them. Note that patches from #900409 and #900410
+#		are required for a reproducible build (available since
+#		4.0.18-2.1).
 # 
 	kmod [linux-any],
 #		depmod.
